<template>
  <div>
    <v-progress-circular v-if="isLoading" indeterminate color="purple" />
    <div v-if="!isLoading" class="ranking-title">Ranking de Especialistas</div>
    <v-tabs
      v-if="!isLoading"
      v-model="tab"
      centered
      color="tway-violet"
      class="my-5"
      show-arrows="mobile"
    >
      <v-tabs-slider color="tway-apple-green" />
      <v-tab class="tabs-title"> Servicio a la Medida </v-tab>
      <v-tab class="tabs-title"> Experiencia en el Sector </v-tab>
      <v-tab class="tabs-title"> Tamaño </v-tab>
    </v-tabs>
    <v-tabs-items v-if="!isLoading" v-model="tab">
      <v-tab-item class="pt-0 pa-5">
        <transition name="fade">
          <div v-if="!getflag1" class="ranking-alert">
            <div class="pa-5 roboto">
              <v-img
                :src="require('@/assets/img/ranking/info.svg')"
                class="rounded"
                max-width="21px"
                contain
              />
              <span
                >Recomendaciones de Servicios y Especialistas para reducir
                brechas según resultados del Índice de Madurez en Transformación
                Digital de tu empresa.</span
              >
              <v-img
                :src="require('@/assets/img/ranking/remove.svg')"
                class="rounded"
                style="cursor: pointer"
                @click="
                  () => {
                    setranking(1);
                  }
                "
                max-width="21px"
                contain
              />
            </div>
          </div>
        </transition>
        <div class="graph-container">
          <v-row
            v-if="zoomableSunburstData.children.length > 0"
            class="pb-6 pa-0 ma-0"
            justify="center"
          >
            <v-img
              :src="require('@/assets/img/ranking/example.svg')"
              class="rounded"
              style="cursor: pointer"
              max-width="450px"
              contain
            />
          </v-row>
          <ZoomableSunburstChart
            v-if="zoomableSunburstData.children.length > 0"
            :data="zoomableSunburstData"
            :width="640"
          />
          <v-row
            v-else
            class="pa-0 ma-0"
            style="max-width: 640px"
            justify="center"
          >
            <div
              class="ma-0 pa-0"
              style="
                display: flex;
                justify-content: center;
                align-items: center;
                flex-direction: column !important;
              "
            >
              <v-img
                :src="require('@/assets/img/ranking/nograph.svg')"
                max-width="250px"
                contain
              />
              <span class="nograph-title py-5"
                >Aún no hay suficiente información para mostrar</span
              >
              <span class="nograph-subtitle roboto"
                >Te invitamos a levantar tu proyecto y comenzar la
                Transformación de tu empresa.</span
              >
            </div>
          </v-row>
        </div>
      </v-tab-item>
      <v-tab-item class="pt-0 pa-5">
        <transition name="fade">
          <div v-if="!getflag2" class="ranking-alert">
            <div class="pa-5 roboto">
              <v-img
                :src="require('@/assets/img/ranking/info.svg')"
                class="rounded"
                max-width="21px"
                contain
              />
              <span
                >Trayectoria de los Especialistas de acuerdo a sectores y
                cantidad de proyectos desarrollados.</span
              >
              <v-img
                :src="require('@/assets/img/ranking/remove.svg')"
                class="rounded"
                style="cursor: pointer"
                @click="
                  () => {
                    setranking(2);
                  }
                "
                max-width="21px"
                contain
              />
            </div>
          </div>
        </transition>
        <div class="graph-container">
          <HierarchicalBarChart
            v-if="hierarchicalBarData.children.length > 0"
            :data="hierarchicalBarData"
            :width="640"
          />
        </div>
      </v-tab-item>
      <v-tab-item class="pt-0 pa-5">
        <transition name="fade">
          <div v-if="!getflag3" class="ranking-alert">
            <div class="pa-5 roboto">
              <v-img
                :src="require('@/assets/img/ranking/info.svg')"
                class="rounded"
                max-width="21px"
                contain
              />
              <span
                >Especialistas agrupados por tamaño según las categorías de
                servicios que ofrecen.</span
              >
              <v-img
                :src="require('@/assets/img/ranking/remove.svg')"
                class="rounded"
                style="cursor: pointer"
                @click="
                  () => {
                    setranking(3);
                  }
                "
                max-width="21px"
                contain
              />
            </div>
          </div>
        </transition>
        <div class="graph-container">
          <ZoomableCirclePackingChart
            v-if="zoomableCirclePackingData.children.length > 0"
            :data="zoomableCirclePackingData"
            :width="640"
          />
        </div>
      </v-tab-item>
    </v-tabs-items>
    <v-row class="pt-3 pa-0 ma-0" justify="center">
      <v-btn
        v-if="!isLoading"
        large
        rounded
        color="tway-violet"
        class="button-text white--text"
        :to="{ name: 'project-foundation' }"
      >
        CREAR PROYECTO
      </v-btn>
    </v-row>
  </div>
</template>

<script>
import ZoomableSunburstChart from "@/components/charts/ZoomableSunburstChart";
import ZoomableCirclePackingChart from "@/components/charts/ZoomableCirclePackingChart";
import HierarchicalBarChart from "@/components/charts/HierarchicalBarChart";
import RankingService from "@/services/rankingService";
import { mapGetters, mapActions } from "vuex";

export default {
  components: {
    HierarchicalBarChart,
    ZoomableSunburstChart,
    ZoomableCirclePackingChart,
  },

  data: () => ({
    tab: 0,
    zoomableSunburstData: {},
    hierarchicalBarData: {},
    zoomableCirclePackingData: {},
    isLoading: true,
  }),

  beforeMount() {
    this.getRanking();
  },

  created() {
    console.log(this.getflag1);
  },

  methods: {
    ...mapActions("ranking", ["setranking"]),
    getRanking() {
      this.zoomableSunburstData = {
        name: "Categorías",
        children: [],
      };

      this.hierarchicalBarData = {
        name: "Sectores",
        children: [],
      };

      this.zoomableCirclePackingData = {
        name: "Sectores",
        children: [],
      };

      RankingService.getByTrajectory()
        .then((ranking) => {
          this.zoomableSunburstData.children = ranking;
          this.isLoading = false;
        })
        .catch((err) => {
          this.isLoading = true;
          console.log(err);
          if (err.response.status === 401) {
            this.$router.push({ name: "my-plan" });
          }
        });

      RankingService.getByNumberOfProjects()
        .then((ranking) => {
          this.hierarchicalBarData.children = ranking;
          this.isLoading = false;
        })
        .catch((err) => {
          this.isLoading = true;
          console.log(err);
          if (err.response.status === 401) {
            this.$router.push({ name: "my-plan" });
          }
        });

      RankingService.getBySize()
        .then((ranking) => {
          this.zoomableCirclePackingData.children = ranking;
          this.isLoading = false;
        })
        .catch((err) => {
          if (err.response.status === 409 || err.response.status === 401) {
            this.$router.push({ name: "my-plan" });
          }
          console.log(err);
          this.isLoading = true;
        });
    },
  },
  computed: {
    ...mapGetters({
      getflag1: "ranking/getflag1",
      getflag2: "ranking/getflag2",
      getflag3: "ranking/getflag3",
    }),
  },
};
</script>

<style scoped lang="scss">
.tabs-title {
  text-transform: none !important;
  font-size: 18px;
}

.nograph-title {
  font-style: normal;
  font-weight: normal;
  font-size: 25px;
  line-height: 32px;
  color: #333333;
}

.nograph-subtitle {
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  color: #333333;
}

.graph-container {
  max-width: 640px;
  margin: 0px auto;
}
.ranking-title {
  font-style: normal;
  font-weight: normal;
  font-size: 25px;
  line-height: 32px;
  display: flex;
  padding-top: 15px;
  justify-content: center;
  color: #333333;
}
.ranking-alert {
  width: 100%;
  display: flex;
  justify-content: center;
  > div {
    max-width: 640px;
    display: flex;
    justify-content: center;
    align-items: center;
    border: 1px solid #7319d5;
    color: #7319d5;
    box-sizing: border-box;
    border-radius: 20px;
    margin-bottom: 40px;
    font-style: normal;
    font-weight: normal;
    font-size: 16px;
    line-height: 24px;
    > span {
      padding-left: 15px;
      padding-right: 15px;
    }
  }
}
</style>
